
setInterval(function() { server_update() },180000); // check for updates once every two minutes

function update_notes(notedata,init)
{
	for(var i=0;i<notedata.length;i++)
	{
		notedata[i].updated=!init;
		var note_el=document.getElementById("note"+notedata[i].id);
		if(!note_el) create_note(notedata[i],false,!init);
		else
		{
			set_note_attributes(note_el,notedata[i],false,true);
		}
	}

	update_note_list();
}

function update_note_list()
{
	var notes_el=document.getElementById("notelist");
	while(notes_el.firstChild) notes_el.removeChild(notes_el.firstChild);

	var deleted_el=document.getElementById("deletedlist");
	while(deleted_el.firstChild) deleted_el.removeChild(deleted_el.firstChild);

	var notenodes=document.getElementById("notes").childNodes;
	var notes=[];
	for(var i=0;i<notenodes.length;i++) notes.push(notenodes[i]);
	notes.sort(function (a,b) { return(a.timestamp>b.timestamp?-1:1) });

	var script=document.location.toString().match(/^([^?]*)/)[1];

	for(var i=0;i<notes.length;i++)
	{
		var history=script+"?task=history&image="+encodeURIComponent(current_image)+"&id="+encodeURIComponent(notes[i].norm_id);
		if(notes[i].notewidth) notes_el.appendChild(make_element({ tag: "li", children: [
			{ tag: "a", href: "javascript:toggle_note("+notes[i].norm_id+")",
			children: [ notes[i].text_store.match(/^(.*)/)[1] ] }," ",
			{ tag: "small", children: [
				"(",{ tag: "a", href: history, children: ["Editing history"]},")"
			]}," ",
			notes[i].title
		]}));
		else deleted_el.appendChild(make_element({ tag: "li", children: [
			{ tag: "a", href: history, children: ["Note "+notes[i].norm_id] },
			" ",notes[i].title
		]}));

		
	}
}

function create_note(attr)
{
	var notes=document.getElementById("notes");
	var id=attr.id;

	var note_el=make_element({ tag: "div", id: "note"+id, className: "note", style_position: "absolute",
	onmousedown: function(e) { lift_note(id); },
	children: [
		{ tag: "img", id: "icon"+id, className: "icon",
		onmousedown: function(e) { drag_note(e,id) },
		ondblclick: function(e) { toggle_note(id) }}
	]});

	set_note_attributes(note_el,attr);

	notes.appendChild(note_el);
}

function set_note_attributes(note_el,attr)
{
	var title;

	var realtime=attr.timestamp<1000000000000?attr.timestamp*1000:attr.timestamp;

	if(attr.fresh) title="New note";
	else if(!attr.w) title="Deleted by "+attr.name+attr.trip+" (ID:"+attr.ip+") on "+(new Date(realtime).toLocaleString());
	else title="Last edited by "+attr.name+attr.trip+" (ID:"+attr.ip+") on "+(new Date(realtime).toLocaleString());

	note_el.style.left=attr.x+"px";
	note_el.style.top=attr.y+"px";
	note_el.setAttribute("title",title);
	note_el.setAttribute("color1",attr.color1);
	note_el.setAttribute("color2",attr.color2);

	note_el.norm_id=attr.id;
	note_el.timestamp=attr.timestamp;
	note_el.text_store=attr.text;
	note_el.notewidth=attr.w;
	note_el.noteheight=attr.h;

	if(attr.fresh) note_el.setAttribute("fresh","true");
	else note_el.removeAttribute("fresh");

	if(attr.updated&&!attr.marked) note_el.setAttribute("updated","true");

	if(!attr.w) note_el.style.display="none";

	note_el.firstChild.setAttribute("src",icon_location(attr.color1,attr.color2));
}



// UI functions

function show_note(id)
{
	var note_el=document.getElementById("note"+id);

	if(!note_el) return;

	var w=note_el.notewidth;
	var h=note_el.noteheight;
	var color1=note_el.getAttribute("color1");
	var color2=note_el.getAttribute("color2");

	note_el.removeAttribute("updated");

	note_el.appendChild(make_element({ tag: "div", id: "full"+id, className: "fullview",
	style_width: w+"px", style_height: h+"px", children: [
		{ tag: "textarea", id: "editor"+id, timestamp: note_el.timestamp,
		style_width: w+"px", style_height: h+"px",
		children: [ note_el.text_store.replace(/\r\n|\r|\n/g,"\r") ] },
		{ tag: "div", className: "resize", children: ["\xa0"],
		onmousedown: function(e) { resize_note(e,id) } },
		{ tag: "div", className: "toolbar", children: [
			{ tag: "input", type: "button", value: "Save", onclick: function(e) { save_note(id) } },
			{ tag: "input", type: "button", value: "Cancel", onclick: function(e) { hide_note(id) } },
			{ tag: "input", id: "morebutton"+id, type: "button", value: "More...", onclick: function(e) { toggle_more(id) } }
		]}
	]}));
}

function hide_note(id)
{
	var note_el=document.getElementById("note"+id);
	var full_el=document.getElementById("full"+id);
	var editor_el=document.getElementById("editor"+id);

	if(!note_el) return;

	note_el.notewidth=parseInt(editor_el.style.width);
	note_el.noteheight=parseInt(editor_el.style.height);

	full_el.parentNode.removeChild(full_el);
}

function show_more(id)
{
	var note_el=document.getElementById("note"+id);
	var full_el=document.getElementById("full"+id);
	var morebutton_el=document.getElementById("morebutton"+id);

	if(!note_el) return;

	full_el.appendChild(make_element({ tag: "div", id: "more"+id, className: "moreview", children: [
		{ tag: "div", children: [
			{ tag: "input", type: "button", value: "Delete", onclick: function(e) { delete_note(id) } },
			{ tag: "input", type: "button", value: "History", onclick: function(e) { goto_history(id) } },
			{ tag: "input", type: "button", value: "Rikai", onclick: function(e) { open_rikai(id) } },
			make_color_selector("Note colors:", function(e,color1,color2) { set_note_colors(id,color1,color2); })
		]}
	]}));

	morebutton_el.value="Less...";
}

function hide_more(id)
{
	var note_el=document.getElementById("note"+id);
	var more_el=document.getElementById("more"+id);
	var morebutton_el=document.getElementById("morebutton"+id);

	if(!note_el) return;

	more_el.parentNode.removeChild(more_el);

	morebutton_el.value="More...";
}

function make_color_selector(title,clickhandler,downhandler)
{
	var colors1=["yellow","magenta","cyan","green","red","blue"];
	var colors2=["cyan","magenta","yellow","green","blue","red"];

	var tbody_el=document.createElement("tbody");

	for(var y=0;y<colors2.length;y++)
	{
		var tr_el=document.createElement("tr");

		for(var x=0;x<colors1.length;x++)
		{
			var img_el=make_element({ tag: "img", src: icon_location(colors1[x],colors2[y]) });
			if(clickhandler) img_el.onclick=function(color1,color2) { return function(e) { clickhandler(e,color1,color2);  } } (colors1[x],colors2[y]);
			if(downhandler) img_el.onmousedown=function(color1,color2) { return function(e) { downhandler(e,color1,color2);  } } (colors1[x],colors2[y]);

			tr_el.appendChild(make_element({ tag: "td", children: [img_el] }));
		}

		tbody_el.appendChild(tr_el);
	}

	return(make_element({ tag: "div", className: "colorselector", children: [
		{ tag: "h3", children: [title] },
		{ tag: "table", children: [tbody_el] }
	]}));
}



// visibility function

function toggle_note(id)
{
	var note_el=document.getElementById("note"+id);
	var full_el=document.getElementById("full"+id);

	if(!note_el) return;

	if(full_el)
	{
		if(note_changed(id))
		if(!confirm("This note has been edited.\nDiscard changes?")) return;

		hide_note(id);
	}
	else
	{
		show_note(id);

		var target_x=get_object_x(note_el);
		var target_y=get_object_y(note_el);
		var delta_w=window.innerWidth-note_el.offsetWidth;
		var delta_h=window.innerHeight-note_el.offsetHeight;

		if(target_x>=window.scrollX && target_x<=window.scrollX+delta_w) target_x=window.scrollX;
		else if(target_x>window.scrollX+delta_w && delta_w>0) target_x-=delta_w;
		if(target_y>=window.scrollY && target_y<=window.scrollY+delta_h) target_y=window.scrollY;
		else if(target_y>window.scrollY+delta_h && delta_h>0) target_y-=delta_h;

		window.scrollTo(target_x,target_y);
	}
}

function toggle_more(id)
{
	var note_el=document.getElementById("note"+id);
	var more_el=document.getElementById("more"+id);

	if(!note_el) return;

	if(more_el) hide_more(id);
	else show_more(id);
}

function show_all()
{
	var notes=document.getElementById("notes").childNodes;
	for(var i=0;i<notes.length;i++)
	{
		var id=notes[i].id.substr(4);
		var full_el=document.getElementById("full"+id);
		if(!full_el) show_note(id);
	}
}

function hide_all()
{
	if(!check_all()) return;

	var notes=document.getElementById("notes").childNodes;
	for(var i=0;i<notes.length;i++)
	{
		var id=notes[i].id.substr(4);
		var full_el=document.getElementById("full"+id);
		if(full_el) hide_note(id);
	}
}



// actions

function new_note()
{
	var menu_el=document.getElementById("menu");

	var color_el=make_color_selector("New note:",null,
	function(e,color1,color2)
	{
		var time=new Date().getTime().toString();

		if(!e) e=window.event;
		var obj=e.srcElement||e.currentTarget;
		var x=get_object_x(obj);
		var y=get_object_y(obj);

		create_note({ id: time, text: "",x: x, y: y, w: 220, h: 120,
		color1: color1,color2: color2, name: "",trip: "", fresh: true});

		color_el.parentNode.removeChild(color_el);

		drag_note(e,time);
	});
	color_el.id="newnote";

	document.getElementsByTagName("body")[0].appendChild(color_el);
}

function save_note(id)
{
	var note_el=document.getElementById("note"+id);
	var editor_el=document.getElementById("editor"+id);

	if(!note_el||!editor_el) return;

	var text=editor_el.value;
	var x=parseInt(note_el.style.left);
	var y=parseInt(note_el.style.top);
	var w=parseInt(editor_el.style.width);
	var h=parseInt(editor_el.style.height);
	var color1=note_el.getAttribute("color1");
	var color2=note_el.getAttribute("color2");
	var timestamp=editor_el.getAttribute("timestamp");
	var name=get_user_name();

	server_save(id,text,x,y,w,h,color1,color2,name,timestamp);

	note_el.text_store=text;
	hide_note(id);
}

function delete_note(id)
{
	var note_el=document.getElementById("note"+id);
	var editor_el=document.getElementById("editor"+id);

	if(!note_el||!editor_el) return;
	if(!confirm("Are you sure you want to delete this note?")) return;

	var timestamp=editor_el.getAttribute("timestamp");
	var name=get_user_name();

	if(!note_el.getAttribute("fresh")) server_delete(id,name,timestamp);

	note_el.parentNode.removeChild(note_el);
}

function goto_history(id)
{
	var scriptname=document.location.toString().match(/^(.*?)\?/)[1];

	if(check_all())
	document.location=scriptname+"?task=history&image="+encodeURIComponent(current_image)+"&id="+encodeURIComponent(id);
}

function open_rikai(id)
{
	var editor_el=document.getElementById("editor"+id);

	if(!editor_el) return;

	var timestamp=editor_el.getAttribute("timestamp");
	var scriptname=document.location.toString().match(/^(.*?)\?/)[1];
	var url=scriptname+"?task=history&image="+encodeURIComponent(current_image)+"&id="+encodeURIComponent(id)+"&timestamp="+encodeURIComponent(timestamp);

	open("http://www.rikai.com/perl/LangMediator.En.pl?mediate_uri="+encodeURIComponent(url));
}

function goto_discussion()
{
	var scriptname=document.location.toString().match(/^(.*?)\?/)[1];

	if(check_all())
	document.location=scriptname+"?task=discussion&image="+encodeURIComponent(current_image);
}

function revert_note(image,id,timestamp)
{
	if(confirm('Are you sure you want to revert this note to this version?'))
	{
		var scriptname=document.location.toString().match(/^(.*?)\?/)[1];
		var name=get_user_name();

		document.location=scriptname+"?task=revert"+
		"&image="+encodeURIComponent(image)+
		"&id="+encodeURIComponent(id)+
		"&timestamp="+encodeURIComponent(timestamp)+
		"&name="+encodeURIComponent(name);
	}
}

function set_note_colors(id,color1,color2)
{
	var note_el=document.getElementById("note"+id);
	var icon_el=document.getElementById("icon"+id);

	if(!note_el) return;

	note_el.setAttribute("color1",color1);
	note_el.setAttribute("color2",color2);
	icon_el.setAttribute("src",icon_location(color1,color2));

	hide_more(id);
}

function toggle_menu()
{
	var menu_el=document.getElementById("menu");
	var content_el=document.getElementById("menucontents");
	if(content_el.style.display) { content_el.style.display=""; menu_el.style.width=""; }
	else { content_el.style.display="none"; menu_el.style.width="auto"; }
}



// note dynamics

function drag_note(e,id)
{
	if(!e) e=window.event;

	var note_el=document.getElementById("note"+id);
	var x_offs=parseInt(note_el.style.left)-get_mouse_x(e);
	var y_offs=parseInt(note_el.style.top)-get_mouse_y(e);

	document.onmousemove=function(e)
	{
		if(!e) e=window.event;

		var x=get_mouse_x(e)+x_offs;
		var y=get_mouse_y(e)+y_offs;
		if(x<0) x=0;
		if(y<0) y=0;
		note_el.style.left=x+"px";
		note_el.style.top=y+"px";
	}

	document.onmouseup=function(e)
	{
		if(!e) e=window.event;

		document.onmouseup=null;
		document.onmousemove=null;
	}

	lift_note(id);

	var obj=e.srcElement||e.currentTarget;
	obj.onselectstart=function() { e.returnValue=false; }
	obj.ondragstart=function() { e.returnValue=false; }

	e.cancelBubble=true;
	if(e.preventDefault) e.preventDefault();
	else return true;
}

function resize_note(e,id)
{
	if(!e) e=window.event;

	var editor_el=document.getElementById("editor"+id);
	var full_el=document.getElementById("full"+id);
	var w_offs=parseInt(editor_el.style.width)-get_mouse_x(e);
	var h_offs=parseInt(editor_el.style.height)-get_mouse_y(e);

	document.onmousemove=function(e)
	{
		if(!e) e=window.event;

		var w=get_mouse_x(e)+w_offs;
		var h=get_mouse_y(e)+h_offs;
		if(w<32) w=32;
		if(h<32) h=32;
		editor_el.style.width=w+"px";
		full_el.style.width=w+"px";
		editor_el.style.height=h+"px";
		full_el.style.height=h+"px";
	}

	document.onmouseup=function(e)
	{
		if(!e) e=window.event;

		document.onmouseup=null;
		document.onmousemove=null;
	}

	var obj=e.srcElement||e.currentTarget;
	obj.onselectstart=function() { e.returnValue=false; }
	obj.ondragstart=function() { e.returnValue=false; }

	e.cancelBubble=true;
	if(e.preventDefault) e.preventDefault();
	else return true;
}

var global_z=1;
function lift_note(id)
{
	var note_el=document.getElementById("note"+id);
	note_el.style.zIndex=global_z++;
}



// helper functions

function note_changed(id)
{
	var note_el=document.getElementById("note"+id);
	var editor_el=document.getElementById("editor"+id);

	var res=
		note_el.text_store.replace(/(\r\n|\r|\n)/g,"\n")
		!=
		editor_el.value.replace(/(\r\n|\r|\n)/g,"\n");
	return res;
}

function check_all()
{
	var notes=document.getElementById("notes").childNodes;
	for(var i=0;i<notes.length;i++)
	{
		var id=notes[i].id.substr(4);
		if(document.getElementById("full"+id))
		{
			if(note_changed(id))
			return confirm("There are notes that have been edited.\nDiscard changes?");
		}
	}
	return(true);
}

function icon_location(color1,color2)
{
	var ext=(document.all&&!document.opera)?".gif":".png"
	return "images/note_"+color1+"_"+color2+ext;
}

function link_confirm(e,msg)
{
	if(!e) e=window.event;

	if(!confirm(msg))
	{
		e.cancelBubble=true;
		if(e.preventDefault) e.preventDefault();
		else return true;
	}
	else return false;
}




// server communication

function server_save(id,text,x,y,w,h,color1,color2,name,oldtime)
{
	server_talk( { task: "save", image: current_image, id: id, text: text, x: x, y: y, w: w, h: h,
	color1: color1, color2: color2, name: name, oldtime: oldtime },
	"Saving...");
}

function server_delete(id,name,oldtime)
{
	server_talk({ task: "delete", image: current_image, id: id, name: name, oldtime: oldtime },"Deleting...");
}

function server_update()
{
	server_talk({ task: "newnotes", image: current_image },"Updating...");
}

function server_talk(message,action)
{
	var notice=make_element({ tag: "div", className: "message", children: [action] });
	document.body.appendChild(notice);

	message.mintime=find_max_timestamp();

	server_request(
		"notes.pl",
		message,
		function(result) {
			var response;
			try { response=eval(result); }
			catch(e) { alert("There was a problem communicating with the server. It replied:\n\n"+result.replace(/(.{72})/g,"$1\n")) }

			if(response.error) alert("The server reported an error: \n\n"+response.error);
			else
			{
				if(response.message) alert(response.message);
				update_notes(response.newnotes);
			}

			notice.parentNode.removeChild(notice);
		}
	);
}

function find_max_timestamp()
{
	var maxtime=0;
	var notes=document.getElementById("notes").childNodes;
	for(var i=0;i<notes.length;i++) if(notes[i].timestamp>maxtime) maxtime=notes[i].timestamp;
	return(maxtime);
}



// user name

function set_user_name()
{
	var oldname=get_cookie("notesname")||"";
	var newname=prompt('Please enter a name to use for your annotations.\nLeave blank to remain anonymous.',oldname);
	if(newname=="") newname="Anonymous";
	if(newname!=null) set_cookie("notesname",newname,365);
}

function get_user_name()
{
	var name=get_cookie("notesname");
	if(!name)
	{
		name=prompt('Please enter a name to use for your annotations.\nLeave blank or cancel to remain anonymous.\nUse the "Set user name" link on the sidebar to change the name later.','');
		if(!name) name="Anonymous";
		set_cookie("notesname",name,365);
	}
	return(name);
}



// utility functions

function get_mouse_x(e)
{
	if(e.pageX) return(e.pageX);
//	else return(e.clientX);
	else return(e.clientX+document.documentElement.scrollLeft+document.body.scrollLeft);
}

function get_mouse_y(e)
{
	if(e.pageY) return(e.pageY);
//	else return(e.clientY);
	else return(e.clientY+document.documentElement.scrollTop+document.body.scrollTop);
}

function get_object_x(obj)
{
	var left=0;
	if(obj.offsetParent)
	{
		while(obj.offsetParent)
		{
			left+=obj.offsetLeft
			if(document.defaultView&&document.defaultView.getComputedStyle&&
			document.defaultView.getComputedStyle(obj,'').getPropertyValue("position")=="fixed") left+=window.scrollX;
			obj=obj.offsetParent;
		}
	}
	else if(obj.x) left+=obj.x;

	return(left);
}

function get_object_y(obj)
{
	var top=0;
	if(obj.offsetParent)
	{
		while(obj.offsetParent)
		{
			top+=obj.offsetTop
			if(document.defaultView&&document.defaultView.getComputedStyle&&
			document.defaultView.getComputedStyle(obj,'').getPropertyValue("position")=="fixed") top+=window.scrollY;
			obj=obj.offsetParent;
		}
	}
	else if(obj.y) top+=obj.y;

	return(top);
}

function get_cookie(name)
{
	with(document.cookie)
	{
		var index=indexOf(name+"=");
		if(index==-1) return '';
		index=indexOf("=",index)+1;
		var endstr=indexOf(";",index);
		if(endstr==-1) endstr=length;
		return unescape(substring(index,endstr));
	}
};

function set_cookie(name,value,days)
{
	if(days)
	{
		var date=new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires="; expires="+date.toGMTString();
	}
	else expires="";
	document.cookie=name+"="+value+expires+"; path=/";
}

function server_request(target,args,handler,sync)
{
	var contents=[];
	for(key in args)
	{
		var value=args[key];
		if(typeof value=="object"&&value.length)
		{
			for(var i=0;i<value.length;i++)
			if(value[i]) contents.push(encodeURIComponent(key)+"="+encodeURIComponent(value[i]));
		}
		else if(value||value==0) contents.push(encodeURIComponent(key)+"="+encodeURIComponent(value));
	}

	var xmlhttp=get_xmlhttp();
	xmlhttp.open("POST",target,!sync);
	xmlhttp.onreadystatechange=function() {
		if(xmlhttp.readyState==4) handler(xmlhttp.responseText);
	}
	if(is_ie()||xmlhttp.setRequestHeader) xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
	xmlhttp.send(contents.join("&"));

	if(sync) handler(xmlhttp.responseText);
}

function get_xmlhttp()
{
	var xmlhttp;
	try { xmlhttp=new ActiveXObject("Msxml2.XMLHTTP"); }
	catch(e1)
	{
		try { xmlhttp=new ActiveXObject("Microsoft.XMLHTTP"); }
		catch(e1) { xmlhttp=null; }
	}

	if(!xmlhttp && typeof XMLHttpRequest!='undefined') xmlhttp=new XMLHttpRequest();

	return(xmlhttp);
}

function make_element(def)
{
	var element;

	if(typeof def=="object")
	{
		if(def.getAttribute) return(def); // already an object

		element=document.createElement(def.tag)

		for(key in def)
		{
			if(key=="tag"||key=="children"); // skip tag and children
			else if(key=="id"||key=="className"||key.match(/^on/)) element[key]=def[key];
			else if(key=="noselect"&&def[key]) disable_select(element);
			else if(key.match(/^style[\._]/)) eval("element."+key.replace(/_/g,".")+"='"+def[key].replace(/[\\']/g,"\\$1")+"'");
			else element.setAttribute(key,def[key]);
		}

		if(def.children)
		for(var i=0;i<def.children.length;i++) element.appendChild(make_element(def.children[i]));
	}
	else element=document.createTextNode(def);

	return(element);
}

function is_ie()
{
	return(document.all&&!document.opera);
}
