use strict;

BEGIN { require "wakautils.pl"; }

use constant NORMAL_HEAD_INCLUDE => q{

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>Thingy</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<link rel="stylesheet" href="notes.css" />
</head>
<body>

<div style="display:none">
<a href="/aaa.pl">Do not click this link. It is here to get rid of mail harvesters.</a>
</div>

};

use constant NORMAL_FOOT_INCLUDE => q{

</body></html>
};



use constant FRONTPAGE_TEMPLATE => compile_template(NORMAL_HEAD_INCLUDE.q{

<h1>Thingy</h1>

<ul>
<loop $images>
	<li><a href="<var $self>?image=<var urlenc($url)>"><var $url></a>
	- Last edited by <var $name><small><var $trip></small> on <var scalar(gmtime $timestamp/1000)></li>
</loop>
</ul>

<form action="<var $self>" method="get">
Image URL: <input type="text" name="image" />
<input type="submit" value="Go" />
</form>

}.NORMAL_FOOT_INCLUDE);



use constant IMAGE_TEMPLATE => compile_template(NORMAL_HEAD_INCLUDE.q{

<img src="<var $image>" alt="" />

<div id="notes"></div>

<h2>Recent edits</h2>
<ul id="notelist"></ul>

<h2>Deleted notes</h2>
<ul id="deletedlist"></ul>

<script type="text/javascript">
var current_image=<var js_string($image)>;
</script>
<script type="text/javascript" src="notes.js">
</script>
<script type="text/javascript">
update_notes(<var $jsnotes>,true);
</script>

<div id="menu">

<a id="hide" href="javascript:toggle_menu()" title="Hide/show menu">X</a>

<div id="menucontents">
<h2>Menu</h2>

<ul>
<li><a href="javascript:new_note()">New note</a></li>
<li><a href="javascript:show_all()">Show all</a></li>
<li><a href="javascript:hide_all()">Hide all</a></li>
<li><a href="javascript:server_update()">Update</a></li>
<li><a href="javascript:set_user_name()">Set user name</a></li>
<li><a href="<var $self>">Front page</a></li>
</ul>
</div>

</div>

}.NORMAL_FOOT_INCLUDE);



use constant HISTORY_TEMPLATE => compile_template(NORMAL_HEAD_INCLUDE.q{

<script type="text/javascript" src="notes.js"></script>

<div class="history">

<h1>Edit history for note
<em><a href="<var $self>?task=history&amp;image=<var urlenc($image)>&amp;id=<var urlenc($id)>"><var $id></a></em>
on image
<em><a href="<var $self>?image=<var urlenc($image)>"><var $image></a></em>
</h1>

<loop $edits>
	<div class="edit">
	<h2><a href="<var $self>?task=history&amp;image=<var urlenc($image)>&amp;id=<var urlenc($id)>&amp;timestamp=<var urlenc($timestamp)>">
	<var $name><small><var $trip> (ID:<var mask_ip($ip,SECRET)>)</small> on <var gmtime $timestamp> UTC
	</a></h2>

	<blockquote color1="<var $color1>">

	<div class="actions">
	<a href="javascript:revert_note(<var js_string($image)>,<var js_string($id)>,<var js_string($timestamp)>)">
	Revert to this version</a>
	</div>

	<var html_br($text)>

	</blockquote>

	</div>
</loop>
</div>

}.NORMAL_FOOT_INCLUDE);

sub html_br($)
{
	my $str=shift;
	$str=~s!(\r\n|\r|\n)!<br />!g;
	return $str;
}

sub text_summary($)
{
	my $text=shift;
	$text=~/^(.*)/;
	return $1;
}

1;